/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2008 by TAKAGI Nobuhisa
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <boost/lexical_cast.hpp>
#include <boost/spirit.hpp>
#include "toppers/misc.hpp"
#include "toppers/global.hpp"
#include "toppers/csv.hpp"
#include "toppers/nm_symbol.hpp"
#include "toppers/s_record.hpp"
#include "toppers/diagnostics.hpp"
#include "toppers/macro_processor.hpp"
#include "toppers/io.hpp"
#include "toppers/cpp.hpp"
#include "toppers/oil/factory.hpp"
#include "toppers/oil/cfg1_out.hpp"

namespace toppers
{
  namespace oil
  {
    namespace
    {

	  object_definition* find_object(string name , cfg1_out::cfg_obj_map const& obj_def_map)
	  {
		  std::map< std::string, std::vector<object_definition*>>::const_iterator p;
		  std::vector<object_definition*>::const_iterator q;
		
		  // OvIuWFNg
		  for(p = obj_def_map.begin() ; p != obj_def_map.end() ; p++)
		  {
			  for(q = (*p).second.begin() ; q != (*p).second.end() ; q++)
			  {
				  if((*q)->get_name() == name)
				  {
					  return (*q);
				  }
			  }
		  }		 
		  return NULL;
	  }

      // J[lIuWFNgE`pÓIAPI̊ep[^}NvZbT̕ϐƂĐݒ肷B
      void set_object_vars( cfg1_out::cfg_obj_map const& obj_def_map, macro_processor& mproc )
      {
        typedef macro_processor::element element;
        typedef macro_processor::var_t var_t;
        std::map< std::string, var_t > order_list_map , obj_parameter;
        std::map< std::string, long > id_map;

		using namespace toppers::oil::oil_definition;
		std::map< std::string, std::vector<object_definition*>>::const_iterator p;
		std::vector<object_definition*>::const_iterator q;
		std::vector<object_parameter_def*>::const_iterator r;

        for ( p = obj_def_map.begin() ; p != obj_def_map.end() ; p++)
        {
			element e;
			var_t t;
			string name;
			long obj_id;
			long param_id;
			
			// p[^̒l
			for(q = (*p).second.begin() ; q != (*p).second.end() ; q++)
			{
				std::map< std::string, var_t > obj_parameter;
				std::map< std::string, var_t >::iterator s;
				obj_id = (*q)->get_id();
				name = (*p).first;
				std::map<std::string , long> id_count;
				std::map<std::string , long>::iterator id_iter;

				// l̎o
				e.i = (*q)->get_id();
				e.s = (*q)->get_name();
				// oXgp̏쐬
				order_list_map[ name ].push_back(e);
				// IuWFNgg̒l
	            mproc.set_var( toppers::toupper(name), obj_id, var_t( 1, e ) );
				
				// IuWFNgo̒l
				for(r = (*q)->get_params()->begin() ; r != (*q)->get_params()->end() ; r++)
				{
					name = (*p).first+ string(".") + (*r)->get_parameter_name();
					e.s = (*r)->get_value();

					if(e.s == string(""))
					{
						continue;
					}

					// oID
					id_iter = id_count.find(name);
					if(id_iter == id_count.end())
					{
						id_count[name] = 0;
						param_id = 0;
					}
					else
					{
						param_id = (*id_iter).second + 1;
						id_count[name] = (*id_iter).second + 1;
					}

					if((*r)->get_type() == oil::TYPE_UINT)
					{
						string value_str(((*r)->get_value()));
						try
						{
							e.i = boost::lexical_cast<unsigned __int64>((*r)->get_value());
						}
						catch( std::exception& exception)
						{
							unsigned __int64 temp;
							// 16ȉꍇ̂ŕϊ
							/// ꂢȂ̂łȂƂ
							if(value_str.find("0x") == 0)
							{
								sscanf_s(value_str.c_str() , "0x%I64x" , &temp);
								e.i = temp;
							}
							else if(value_str.find("0X") == 0)
							{
								sscanf_s(value_str.c_str() , "0X%I64x" , &temp);
								e.i = temp;
							}
							else
							{
								// LXgɎs0ɂĂ
								e.i = 0;
							}

						}
					}
					else if((*r)->get_type() == oil::TYPE_INT)
					{
						string value_str(((*r)->get_value()));
						try
						{
							e.i = boost::lexical_cast<__int64>(value_str);
						}
						catch(std::exception& exception)
						{
							__int64 temp;
							// 16ȉꍇ̂ŕϊ
							/// ꂢȂ̂łȂƂ
							if(value_str.find("0x") == 0)
							{
								sscanf_s(value_str.c_str() , "0x%I64x" , &temp);
								e.i = temp;
							}
							else if(value_str.find("0X") == 0)
							{
								sscanf_s(value_str.c_str() , "0X%I64x" , &temp);
								e.i = temp;
							}
							else
							{
								// LXgɎs0ɂĂ
								e.i = 0;
							}
						}
					}
					else if((*r)->get_type() == oil::TYPE_REF)
					{
						object_definition *obj;
						string refefence_obj_type;

						// IuWFNgID̒T
						e.i = 0;
						obj = find_object((*r)->get_value() , obj_def_map);
						if(obj != NULL)
						{
							e.i = obj->get_id();
						}
					}
					else
					{
						e.i = 0;
					}
					obj_parameter[name].push_back(e);
				}

				for(s = obj_parameter.begin() ; s != obj_parameter.end() ; s++)
				{
					mproc.set_var((*s).first , obj_id , (*s).second );
				}
			}

		}
		// Xg̍쐬
        for ( std::map< std::string, var_t >::const_iterator iter( order_list_map.begin() ), last( order_list_map.end() );
              iter != last;
              ++iter )
        {
          // oXg $OBJ.ORDER_LIST$ -- IDԍ̕
          mproc.set_var( toppers::toupper( iter->first + ".order_list" ), iter->second );
          var_t rorder_list( iter->second );

          // tXg $OBJ.RORDER_LIST$ -- IDԍ̕
          std::reverse( rorder_list.begin(), rorder_list.end() );
          mproc.set_var( toppers::toupper( iter->first + ".rorder_list" ), rorder_list );

          // IDԍXg $OBJ.ID_LIST$ -- IDԍ̕
          var_t id_list( iter->second );
          std::sort( id_list.begin(), id_list.end() );
          mproc.set_var( toppers::toupper( iter->first + ".id_list" ), id_list );
        }
	  }


      // vbgtH[ERpCˑ̒l}NvZbT̕ϐƂĐݒ肷B
      void set_platform_vars( cfg1_out const& cfg1out, macro_processor& mproc )
      {
        typedef macro_processor::element element;
        typedef macro_processor::var_t var_t;

        cfg1_out::cfg1_def_table const* def_table = cfg1out.get_def_table();
        std::size_t sizeof_signed_t;

        static cfg1_out::cfg1_def_t const limit_defs[] =
        {
          { false, "TOPPERS_cfg_CHAR_BIT",  "CHAR_BIT" },
          { false, "TOPPERS_cfg_CHAR_MAX",  "CHAR_MAX" },
          { true, "TOPPERS_cfg_CHAR_MIN",  "CHAR_MIN" },
          { false, "TOPPERS_cfg_SCHAR_MAX", "SCHAR_MAX" },  // {͕tAɂȂ邱Ƃ͂Ȃ
          { false, "TOPPERS_cfg_SHRT_MAX",  "SHRT_MAX" },   // {͕tAɂȂ邱Ƃ͂Ȃ
          { false, "TOPPERS_cfg_INT_MAX",   "INT_MAX" },    // {͕tAɂȂ邱Ƃ͂Ȃ
          { false, "TOPPERS_cfg_LONG_MAX",  "LONG_MAX" },   // {͕tAɂȂ邱Ƃ͂Ȃ
        };

        nm_symbol::entry nm_entry = cfg1out.get_syms()->find( "TOPPERS_cfg_sizeof_signed_t" );
        sizeof_signed_t = static_cast< std::size_t >( cfg1out.get_srec()->get_value( nm_entry.address, 4, cfg1out.is_little_endian() ) );

        for ( std::size_t i = 0; i < sizeof limit_defs / sizeof limit_defs[ 0 ]; ++i )
        {
          element e;
          e.s = limit_defs[ i ].expression;
          nm_entry = cfg1out.get_syms()->find( limit_defs[ i ].name );
          std::tr1::int64_t value = cfg1out.get_srec()->get_value( nm_entry.address, sizeof_signed_t, cfg1out.is_little_endian() );
          if ( sizeof_signed_t < 8 && limit_defs[ i ].is_signed )
          {
            value = cfg1_out::make_signed( static_cast< std::tr1::uint32_t >( value ) );
          }
          mproc.set_var( e.s, var_t( 1, e ) );
        }

        for ( cfg1_out::cfg1_def_table::const_iterator iter( def_table->begin() ), last( def_table->end() );
              iter != last;
              ++iter )
        {
          element e;
          e.s = iter->expression;
          nm_entry = cfg1out.get_syms()->find( "TOPPERS_cfg_" + iter->name );
          if ( nm_entry.type >= 0 )
          {
            std::tr1::int64_t value = cfg1out.get_srec()->get_value( nm_entry.address, sizeof_signed_t, cfg1out.is_little_endian() );
            if ( sizeof_signed_t < 8 && iter->is_signed )
            {
              value = cfg1_out::make_signed( static_cast< std::tr1::uint32_t >( value ) );
            }
            e.i = value;
            mproc.set_var( iter->name, var_t( 1, e ) );
          }
        }

        // oCgI[_[
        {
          bool little_endian = cfg1out.is_little_endian();
          element e;
          e.i = little_endian;
          mproc.set_var( "LITTLE_ENDIAN", var_t( 1, e ) );

          e.i = !little_endian;
          mproc.set_var( "BIG_ENDIAN", var_t( 1, e ) );
        }
      }

    }

    //! RXgN^
    factory::factory( std::string const& kernel )
      : kernel_( tolower( kernel ) )
    {
    }

    //! fXgN^
    factory::~factory()
    {
    }

    //! T|[gĂIuWFNg̎擾
	std::vector<std::string> const* factory::get_object_definition_info() const
    {
      // CSVÓIAPIǂݎAo^邽߂̃[JNX
      struct init_t
      {
        init_t()
        {
          boost::any t = global( "api-table" );
          if ( !t.empty() )
          {
            std::vector< std::string > api_tables( boost::any_cast< std::vector< std::string >& >( t ) );
            for ( std::vector< std::string >::const_iterator iter( api_tables.begin() ), last( api_tables.end() );
                  iter != last;
                  ++iter )
            {
              std::string buf;
              read( iter->c_str(), buf );
	          csv data( buf.begin(), buf.end() );
              for ( csv::const_iterator d_iter( data.begin() ), d_last( data.end() );
                    d_iter != d_last;
                    ++d_iter )
              {
                  unsigned int i;
                  for(i = 0 ; i < d_iter->size() ; i++)
                  {
                      volatile int x = 1;
                      object_definition_table.push_back((*d_iter)[i].c_str());
                  }
              }

            }
          }
        }

        ~init_t()
        {

        
        }

		std::vector<std::string> object_definition_table;
      };
      static init_t init;
	  std::vector<std::string> const* result = &init.object_definition_table;
      return result;
    }

    /*!
     * \brief   cfg1_out.c ւ̏o͏e[u̐
     * \return   cfg1_out::cfg1_def_table IuWFNgւ̃|C^
     * \note    ̊֐Ԃ|C^ delete Ă͂ȂȂ
     *
     * --cfg1-def-table IvVŎw肵t@CAcfg1_out.c ֏o͂ǂݎA
     * cfg1_out::cfg1_def_table IuWFNg𐶐B
     *
     * CSV ̌`͈ȉ̒ʂ
     *
     *    V{,[,s|signed]
     *
     *  s ܂ signed ͏ȗ\Bȗ͕Ƃ݂ȂBs ܂ signed w莞
     * tƂ݂ȂB\n
     * uv̍ŏ # ΑOƂ݂ȂB
     */
    cfg1_out::cfg1_def_table const* factory::get_cfg1_def_table() const
    {
      struct init_t
      {
        init_t()
        {
          boost::any t = global( "cfg1-def-table" );
          if ( !t.empty() )
          {
            std::vector< std::string > cfg1_def_table = boost::any_cast< std::vector< std::string >& >( t );
            for ( std::vector< std::string >::const_iterator iter( cfg1_def_table.begin() ), last( cfg1_def_table.end() );
                  iter != last;
                  ++iter )
            {
              std::string buf;
              read( iter->c_str(), buf );
              csv data( buf.begin(), buf.end() );
              for ( csv::const_iterator d_iter( data.begin() ), d_last( data.end() );
                    d_iter != d_last;
                    ++d_iter )
              {
                csv::size_type len = d_iter->size();
                if ( len < 2 )
                {
                  toppers::fatal( _( "too little fields in `%1%\'" ), *iter );
                }
                cfg1_out::cfg1_def_t def = { 0 };
                def.name = ( *d_iter )[ 0 ];
                def.expression = ( *d_iter )[ 1 ];
                if ( len >= 3 )
                {
                  std::string is_signed( ( *d_iter )[ 2 ] );
                  def.is_signed = ( is_signed == "s" || is_signed == "signed" );
                }
                cfg1_def_table_.push_back( def );
              }
            }
          }
        }
        cfg1_out::cfg1_def_table cfg1_def_table_;
      };
      static init_t init;
      cfg1_out::cfg1_def_table const* result = &init.cfg1_def_table_;
      return result;
    }

    //! IuWFNǧ
    void factory::do_swap( factory& other )
    {
      kernel_.swap( other.kernel_ );
    }

    macro_processor::hook_t factory::do_get_hook_on_assign() const
    {
//      return &hook_on_assign;
      return 0;
    }

    /*!
     *  \brief  }NvZbT̐
     *  \param[in]  hook    ϐɒlۂ̃tbN
     *  \param[in]  cfg1out cfg1_out IuWFNg
     *  \param[in]  api_map .cfg t@CɋLqꂽÓIAPI
     *  \return     }NvZbTւ̃|C^
     */
    std::auto_ptr< macro_processor > factory::do_create_macro_processor( macro_processor::hook_t hook, cfg1_out const& cfg1out, cfg1_out::cfg_obj_map const& obj_def_map ) const
    {
      typedef macro_processor::element element;
      typedef macro_processor::var_t var_t;
      std::auto_ptr< macro_processor > mproc( new macro_processor( hook ) );
      element e;

      e.s = " ";    mproc->set_var( "SPC", var_t( 1, e ) );  // $SPC$
      e.s = "\t";   mproc->set_var( "TAB", var_t( 1, e ) );  // $TAB$
      e.s = "\n";   mproc->set_var( "NL",  var_t( 1, e ) );  // $NL$

      // o[W
      e.s = toppers::get_global< std::string >( "version" );
      e.i = toppers::get_global< std::tr1::int64_t >( "timestamp" );
      mproc->set_var( "CFG_VERSION", var_t( 1, e ) );   // $CFG_VERSION$

      // ̑̑gݍݕϐ̐ݒ
      set_object_vars( obj_def_map, *mproc );
      set_platform_vars( cfg1out, *mproc );
      return mproc;
    }

    std::auto_ptr< cfg1_out > factory::do_create_cfg1_out( std::string const& filename ) const
    {
      return std::auto_ptr< oil::cfg1_out >( new cfg1_out( filename, get_cfg1_def_table() ) );
    }

  }
}
